/* Initialize browser variables. */
var NS4 = (document.layers); // NS4 or some other browser, usually IE.
var NS6 = ((document.getElementById)&&(!document.all)); // Also Mozilla.
var KeepMenu = 1;

/*
These variables contain the HTMl <layer> tag that is needed in order for the menus 
to work in Netscape 4.x.  However, having the <layer> tag present causes serious 
problems in Mozilla, Netscape 6.x, and other Gecko-based browsers like Galeon.

At each position that requires a <layer> tag, that is, after each menu <div> starts and 
before each menu </div>, you need to put in a script that writes in the opening and 
closing <layer> tag.  EG:

<script> if(NS4){document.writeln(LayerOpen);}</script> <!-- start of layer tag for NS 4 -->
<script> if(NS4){document.writeln(LayerClose);}</script> <!-- close of layer tag for NS 4 -->

This is a rather kludgy workaround that adds complexity to the script because it requires 
you to put a whole bunch of <script> commands into the document.  Hopefully the 
Mozilla bug (Bugzilla bug ID #102792) will get fixed, thereby rendering this workaround 
unnecessary.  However, it might take a while.
*/
var LayerOpen = "<layer onMouseOver=\"Extender();\" onMouseOut=\"HideDelay();\">";
var LayerClose = "</layer>";

/*
This function Hides all submenus.  Each of the main menu links calls 
this function, so that moving your mouse over a link hides all 
submenus.  If a menu link has its own submenu, then that link also 
calls PopUp() after it has finished called Hide().

Also, it cancels pending calls to HideDelay(), so that menus do not 
vanish unexpectedly.  Hence the clearTimeout call.  The TimerID must be checked 
first to see if it's set, otherwise an error will be generated when the script tries 
to clear a timeout that hasn't been set.

Hide requires an array, MenuList, to be set in the page itself. MenuList is a list of 
the names of all the menus on the page.  This makes the script considerably more 
portable, since you don't have to modify the script source file for each page you want 
it to work on.
*/
function Hide(){
	if (this.TimerID){
		window.clearTimeout(this.TimerID);
	}
	for (i = 0; i < MenuList.length; i++){ // Cycle through the list of menus and hide them.
		eval("PopUp('"+MenuList[i]+"', 0)");
	}
}


/*
PopUp() reveals or hides a given submenu.  MenuName specifies which 
menu should be altered, and on is a boolean value.  If the function 
is called with on specified as "1", then the menu is revealed.  If 
on is specified as "0" then the menu is hidden.  
*/
function PopUp (MenuName, on) {
	KeepMenu = 1;
	if (on){
		if (NS4) {
			document.layers[MenuName].visibility = "show";
		} else if (NS6){
			CurrentMenu = document.getElementById(MenuName);
			CurrentMenu.style.visibility = "visible";
		} else {
			document.all[MenuName].style.visibility = "visible";
		}
	} else {
		if (NS4) {
			document.layers[MenuName].visibility = "hide";
		} else if (NS6){
			CurrentMenu = document.getElementById(MenuName);
			CurrentMenu.style.visibility = "hidden";
		} else {
			document.all[MenuName].style.visibility = "hidden";
		}
	}
}

/*
HideDelay() is called from the OnMouseOut of those menu items that 
have sub-menus to pop up.  When a user moves off the parent link,
HideDelay() checks to see if KeepMenu is true, which it is because it 
was set by PopUp().  So, it sets KeepMenu to false and sets a timeout 
to call itself in half a second.  Meanwhile, if the user moves the mouse 
over the submenu that is being displayed, Extender() is called, which cancels 
the timeout request, leaving the menu in place.  

HideDelay() is also called from the OnMouseOut of the submenu, so that the 
submenu will vanish once someone has moved on to other things.
*/
function HideDelay(KeepMenu) {
	if (KeepMenu == 0){
		Hide();
	} else { 
		KeepMenu = 0;
		this.TimerID = window.setTimeout('HideDelay('+KeepMenu+')', 500);
	}
}

/*
Extender() is called from the table that each submenu is kept in, and 
also from each link in the submenu.  When it is called, it clears the 
existing Timeout call to HideDelay().

Netscape doesn't recognize OnMouseOver or OnMouseOut events for the 
<table> tag, so each table is encapsulated in a <layer> tag with the 
same calls to Extender() and HideDelay().  This ensures that the 
menus work the same in both Netscape and IE.  As of version 1.1, the <layer> 
tag is inserted into the page by an embedded script; see InsertLayer();
*/
function Extender(){
	if (this.TimerID){
		window.clearTimeout(this.TimerID);
	}
}
